#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2003 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################
#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use easylist;

#$version = "EasyList 1.0 Beta";
&get_setup;
$q = CGI->new;

$default_permissions = 0777;  ### DEFAULT PERMISSIONS THAT IS USED FOR DATA FILES IN DATA DIRECTORY


##################################################################################

print "Content-type: text/html\n\n";

$uemail = $q->param('e');
$rcode = $q->param('c');

$cdata = easylist::get_file_contents("$data_dir/to_confirm.dat");
@citems = split (/\n/, $cdata);

$nowtime = time();
$remaining = "";

foreach $item (@citems)
	{
	($cemail, $tyd, $rndcode) = split (/::/, $item);
	
	$rtyd = $nowtime - $tyd;
	
		if (($cemail eq $uemail) and ($rndcode eq $rcode))
			{
			&confirm_email_address($cemail);
			$econfirm = "true";
			}
			elsif ($rtyd < 604800)
			{
			$remaining = $remaining . $item . "\n";
			}
	
	}

open (RTYD, "> $data_dir/to_confirm.dat");
	print RTYD $remaining;
close (RTYD);


if ($econfirm eq "true")
	{
	$sbsuc = easylist::get_file_contents("$data_dir/subs_success.html");
	}
	else
	{
	$sbsuc = easylist::get_file_contents("$data_dir/problem.html");
	}


print $sbsuc;





##########################################

sub confirm_email_address
{
my ($eml_tow) = @_;

open (RTYD, ">> $data_dir/email.lst");
	print RTYD $eml_tow . "\n";
close (RTYD);

## SEND WELCOME EMAIL

$ewelcome = easylist::get_file_contents("$data_dir/welcome.eml");

@elines = split (/\n/, $ewelcome);

$from_name = $elines[0];
$from_email = $elines[1];
$email_subject = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$email_message = $email_message . $line . "\n";
		}
	$lnc++;
	}


$unsl = "$script_url/sbs.cgi";
$email_message =~ s/%%usubscribe_link%%/$unsl/g;
easylist::send_mail($smail, $from_name, $from_email, $eml_tow, $email_subject, $email_message, "NORMAL");

}




sub get_setup
{

$exists = (-e "config.cgi");
if ($exists > 0)
	{
	
	open (STP, "config.cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^WEBDIR/){$webdir = &get_setup_line($line, WEBDIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}
if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}
if ($line =~ /^SMAIL/){$smail = &get_setup_line($line, SMAIL);}

			}
	close (STP);
	
	}
}


sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################
